 {$define debug}
{$define timer}
{Author: Bilbo
 Email:hcl@post.cz
 WWW: freeweb.coco.cz/petricm
 Purpose of program: Find duplicate textures and/or names in wad2 files
 Version: v1.2, 11.9.1999
 -------------------------------------------
 This program is freeware. You can do whatever you want with it, but
 leave this notice unmodified. If you modify this program in any way,
 please notice this fact either in the program or in the documentation.
 If you modify this utility to be better in any way, plese send the
 source code back to the author.}
{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{debug - $A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V-,X+,Y-}
{$ifdef DPMI}
{$M 65520}
{$else}
{$M 65520,0,655360}
{$endif}
uses dos;
const
 maxtex=4095;
 maxfiles=512;
 filebuffersize=16384{32768};
 stat:array[0..6]of string[51]=
 (': (0) Unique texture, unique name.'#13#10
 ,': (1) Duplicate texture, unique name.'#13#10
 ,': (2) Unique texture, name used elsewhere.'#13#10
 ,': (3) Duplicate texture, duplicate name.'#13#10
 ,': (4) Pixel-similar texture, unique name.'#13#10
 ,': (5) - ERROR -'#13#10
 ,': (6) Pixel-similar texture, name used elsewhere.'#13#10);
type
 aa=record
 case integer of
  0:(ch:array[0..3]of char);
  1:(lo:longint);
 end;
 tex1=string[15];
 tex2=record
  fpos,fsize:longint;
  x,y:longint;
 end;
 tex3=array[0..3]of longint;
 texa=array[0..maxtex-1]of tex1;
 texb=array[0..maxtex-1]of tex2;
 texc=array[0..maxtex-1]of tex3;
 dupe=record
  f_w,t_w:byte;
  f_t,t_t:word;
 end;
 mipin=record
  x:longint;
  y:longint;
  o1,o2,o3,o4:longint;
  t3:tex3;
 end;
 wadr=record
  pos:longint;
  len1:longint;
  len2:longint;
  typ:byte;
  com:byte;
  pad:byte;
  name:string[16];
 end;
 dlist=array[0..10919] of dupe;
 dlist2=array[0..10919] of byte;
 bu=array[0..8191] of longint;
 bu2=array[0..32767] of byte;
 pu=^bu2;

function gettick:longint;assembler;
asm
 mov ah,2ch
 int 21h

 mov al,dl
 xor ah,ah
 mov bh,10
 div bh
 mov dl,al{setiny/10}

 mov al,10{0}
 mul dh
 xor dh,dh
 add ax,dx
 mov bx,ax {bx:=s*100+t}
 mov al,60
 mul ch
 xor ch,ch
 add ax,cx {ax:=h*60+m}
 mov si,600{0}
 mul si
 add ax,bx
 adc dx,1
end;

procedure lowstr(var s:string);assembler;
asm
  les di,[s]
  mov cl,es:[di]
  xor ch,ch
@c:
  inc di
  MOV AL,es:[di]
  CMP AL,'A'
  JB @1
  CMP AL,'Z'
  JA @1
  SUB AL,'A'-'a'
@1:MOV es:[di],al
  loop @c
end;

const wadid:aa=(ch:'WAD2');
var
 s1,s2:tex1;
 mip:mipin;
 pix1,pix2:array[0..255] of longint;
 wads:array[1..maxfiles] of string[80];
 wadt:array[1..maxfiles] of word;
 texi1:array[1..maxfiles] of ^texa;
 texi2:array[1..maxfiles] of ^texb;
 texi3:array[1..maxfiles] of ^texc;
 texi4:array[1..maxfiles] of ^texc;
 d:searchrec;
 tero,ok,ii,i,j,k,l,m,n:integer;
 f,g:file;
 pix,csus,iq,chin,csen,ins,cro,nli,part,err,list,ptex:boolean;
 c1,c2,d1,d2:char;
 fwad,s,tw,jwad,kwad:string;
 fmas:string;
 {$ifdef debug}tmem:longint;{$endif}
 tmip,stex,itex,tob,inam,bbit,tbyt,byts,fpro,tlwad,twade,wade,ento,lwad,iwad:longint;
 maxnum,nwad:word;
 du:^dlist;
 du2:^dlist2;
 dui:word;
 wadre:wadr;
 b1,b2:^bu;
procedure error(s:string);
begin
 write(s);
 halt;
end;

procedure werror(s:string);
begin
 write(s);
 inc(tero);
 if not(err) then
 begin
  write('You can ignore this error if you add -w option to the command line'#13#10);
  halt;
 end;
end;

{function strl(i:longint):string;
var
 s:string[11];
begin
 str(i:9,s);
 strl:=s;
end;}

function strl(i:longint;pos:word):string;assembler;
 asm
  mov si,[pos]
  xor cx,cx
  db 66h;xor bx,bx
  mov bl,10
  db 66h;mov ax,word [i]
 @1:
  db 66h;xor dx,dx
  db 66h;div bx
  push dx
  inc cx
  db 66h;cmp ax,0;dw 0
  jne @1
  cmp cx,si
  jnl @3
 @4:
  push dword (' '-'0')
  inc cx
  cmp cx,si
  jl @4
 @3:
  les di,[bp+offset @result]
  mov es:[di],cl
 @2:
  pop ax
  add al,'0'
  inc di
  mov es:[di],al
  loop @2
 end;


function strul(i:longint):string;assembler;
 asm
  xor cx,cx
  db 66h;xor bx,bx
  mov bl,10
  db 66h;mov ax,word [i]
 @1:
  db 66h;xor dx,dx
  db 66h;div bx
  push dx
  inc cx
  db 66h;cmp ax,0;dw 0
  jne @1
  les di,[bp+offset @result]
  mov es:[di],cl
 @2:
  pop ax
  add al,'0'
  inc di
  mov es:[di],al
  loop @2
 end;

procedure cmpt(ii,jj,kk,ll:integer);
var p,q:^tex2;
begin
 if pix then begin
  if texi4[ii]^[jj][0]=texi4[kk]^[ll][0] then
  begin
   if part then Write('Similar:',texi1[ii]^[jj],' / ',wads[ii],' = ',texi1[kk]^[ll],' / ',wads[kk],#13#10);
   with (du^[dui]) do
   begin
    f_w:=ii;
    t_w:=kk;
    f_t:=jj;
    t_t:=ll;
   end;
   du2^[dui]:=du2^[dui] and 2;
   inc(dui);
   if dui=10920 then error('Too many similar textures (max. 10920).');
  end;
 end else begin
 p:=@(texi2[ii]^[jj]);
 q:=@(texi2[kk]^[ll]);
 if (p^.x=q^.x) and (p^.y=q^.y) then
 begin
  p:=@(texi3[ii]^[jj]);
  q:=@(texi3[kk]^[ll]);
  if (tex3(p^)[0]=tex3(q^)[0])and(tex3(p^)[1]=tex3(q^)[1])and(tex3(p^)[2]=tex3(q^)[2])and(tex3(p^)[3]=tex3(q^)[3]) then
  begin
   p:=@(texi4[ii]^[jj]);
   q:=@(texi4[kk]^[ll]);
   if (tex3(p^)[0]=tex3(q^)[0])and(tex3(p^)[1]=tex3(q^)[1])and(tex3(p^)[2]=tex3(q^)[2])and(tex3(p^)[3]=tex3(q^)[3]) then
   begin
    if part then Write('Similar:',texi1[ii]^[jj],' / ',wads[ii],' = ',texi1[kk]^[ll],' / ',wads[kk],#13#10);
    with (du^[dui]) do
    begin
     f_w:=ii;
     t_w:=kk;
     f_t:=jj;
     t_t:=ll;
    end;
    du2^[dui]:=du2^[dui] and 2;
    inc(dui);
    if dui=10920 then error('Too many similar textures (max. 10920).');
   end;
  end;
 end;
 end;
end;

function equal(l,j,m,k:integer):byte;
begin
 equal:=0;
 assign(f,wads[l]);
 assign(g,wads[m]);
 reset(f,1);
 reset(g,1);
 seek(f,texi2[l]^[j].fpos+40);
 seek(g,texi2[m]^[k].fpos+40);
 bbit:=texi2[l]^[j].x*texi2[l]^[j].y;
 byts:=bbit;
 ok:=0;
   while (bbit>0) and (ok=0) do
   begin
    tob:=bbit;
    if tob>filebuffersize then tob:=filebuffersize;
    blockread(f,b1^,tob);
    blockread(g,b2^,tob);
    for n:=0 to (tob div 4)-1 do
    begin
     if b1^[n]<>b2^[n] then
     begin
      ok:=1;break;
     end;
    end;
    dec(bbit,tob);
   end;
   {checkfordupe}
   if iq and (ok=0) then
    begin
     c1:=texi1[l]^[j][1];
     d1:=texi1[m]^[k][1];
     c2:=texi1[l]^[j][2];
     d2:=texi1[m]^[k][2];
     if ((c1='+') and (d1<>'+')) or ((d1='+') and (c1<>'+')) then ok:=1
     else if ((c1='*') and (d1<>'*')) or ((d1='*') and (c1<>'*')) then ok:=1
     else if ((c1='+') and (d1='+')) then begin
     if (copy(texi1[l]^[j],3,255)=copy(texi1[m]^[k],3,255)) and (c2<>d2) then ok:=1;
     end;
    end;
   if ok=0 then begin
    equal:=1;
    inc(tbyt,byts);
    inc(itex);
   end;
   if pix and (ok=1) then begin
    seek(f,texi2[l]^[j].fpos+40);
    seek(g,texi2[m]^[k].fpos+40);
    bbit:=byts;
    for ok:=0 to 255 do
    begin
     pix1[ok]:=0;
     pix2[ok]:=0;
    end;
    while (bbit>0) do
    begin
     tob:=bbit;
     if tob>filebuffersize then tob:=filebuffersize;
     blockread(f,b1^,tob);
     blockread(g,b2^,tob);
     for n:=0 to (tob)-1 do
     begin
      inc(pix1[pu(b1)^[n]]);
      inc(pix2[pu(b2)^[n]]);
     end;
     dec(bbit,tob);
    end;
    ok:=0;
    for n:=0 to 255 do
    begin
     if pix1[n]<>pix2[n] then
     begin
      ok:=1;
      break;
     end;
    end;
    if iq and (ok=0) then
    begin
     c1:=texi1[l]^[j][1];
     d1:=texi1[m]^[k][1];
     c2:=texi1[l]^[j][2];
     d2:=texi1[m]^[k][2];
     if ((c1='+') and (d1<>'+')) or ((d1='+') and (c1<>'+')) then ok:=1
     else if ((c1='*') and (d1<>'*')) or ((d1='*') and (c1<>'*')) then ok:=1
     else if ((c1='+') and (d1='+')) then begin
     if (copy(texi1[l]^[j],3,255)=copy(texi1[m]^[k],3,255)) and (c2<>d2) then ok:=1;
     end;
    end;
    if ok=0 then
    begin
     equal:=4;
     inc(stex);
    end;
   end;
   close(f);
   close(g);
end;

procedure cmpta(jj,kk,ll:integer);
var p,q:^tex2;
begin
 if pix then begin
  if texi4[1]^[jj][0]=texi4[kk]^[ll][0] then
  {if (du2^[j] and 1=0) then }du2^[j]:=du2^[j] or equal(1,jj,kk,ll);
 end else begin
 p:=@(texi2[1]^[jj]);
 q:=@(texi2[kk]^[ll]);
 if (p^.x=q^.x) and (p^.y=q^.y) then
 begin
  p:=@(texi3[1]^[jj]);
  q:=@(texi3[kk]^[ll]);
  if (tex3(p^)[0]=tex3(q^)[0])and(tex3(p^)[1]=tex3(q^)[1])and(tex3(p^)[2]=tex3(q^)[2])and(tex3(p^)[3]=tex3(q^)[3]) then
  begin
   p:=@(texi4[1]^[jj]);
   q:=@(texi4[kk]^[ll]);
   if (tex3(p^)[0]=tex3(q^)[0])and(tex3(p^)[1]=tex3(q^)[1])and(tex3(p^)[2]=tex3(q^)[2])and(tex3(p^)[3]=tex3(q^)[3]) then
    du2^[j]:=du2^[j] or equal(1,jj,kk,ll);
  end;
 end;
 end;
end;

procedure load_wadfile(jwad:string);
var qe:word;
label x1;
begin
  lowstr(jwad);
  for qe:=1 to nwad do if wads[qe]=jwad then exit;
  assign(f,jwad);
  reset(f,1);
  if ioresult<>0 then error('Error opening file "'+jwad+'"!'#13#10);
  lwad:=filesize(f);
  if lwad<12 then
  begin
   werror(jwad+': File too small (not a WAD2)'#13#10);
   write('File ',jwad,' ignored.'#13#10);
   wade:=0;
   ento:=0;
   goto x1;
  end;
  seek(f,0);
  blockread(f,iwad,4);
  blockread(f,wade,4);
  blockread(f,ento,4);
  if iwad<>wadid.lo then
  begin
   werror(jwad+': this is not WAD2.'#13#10);
   write('File ',jwad,' ignored.'#13#10);
   wade:=0;
   ento:=0;
   goto x1;
  end;
  kwad:=jwad+'           ';
  kwad[0]:=#12;
  write(kwad,' -> File size:',strl(lwad,9),'  Entries:',strl(wade,7),'   Table size:',strl((lwad-ento),8),#13#10);
  if (ento+32*wade)<>lwad then error('WAD2 file corrupted or bad format.'#13#10);
  if wade>maxtex then error('Error: This program support max. 4095 entries per WAD2 file.'#13#10);
  if wade=0 then
  begin
    werror('Error in file '+jwad+': No entries. WAD2 file is empty.'#13#10);
   goto x1;
  end;
  if not(list) then
  begin
   inc(nwad);
   tmip:=0;
   if nwad>maxfiles then error('Too many wadfiles. 512 is maximum'#13#10);
   wads[nwad]:=jwad;
   wadt[nwad]:=wade;
   getmem(texi1[nwad],(wade)*sizeof(tex1));
   getmem(texi2[nwad],(wade)*sizeof(tex2));
   if not(pix) then begin
    getmem(texi3[nwad],(wade)*sizeof(tex3));
    {$ifdef debug}inc(tmem,longint(wade*(sizeof(tex3))));{$endif}
   end;
   getmem(texi4[nwad],(wade)*sizeof(tex3));
   {$ifdef debug}inc(tmem,longint(wade*(sizeof(tex1)+sizeof(tex2)+sizeof(tex3))));{$endif}
   seek(f,ento);
   for i:= 0 to wade-1 do
   begin
    blockread(f,wadre,32);
    if ioresult<>0 then error('File error reading table (Wadfile may be corrupted)'#13#10);
    wadre.name[0]:=#99;
    for j:=1 to 16 do
    if wadre.name[j]=#0 then
    begin
     wadre.name[0]:=chr(j-1);
     break;
    end;
    if wadre.name[0]=#0 then
     error('Error: Texture name cannot be empty string'#13#10'WAD:'+jwad+#13#10'texture n.'+strl(i+1,1)+#13#10);
    if wadre.name[0]=#99 then
     error('Error: texture name is not zero-terminated string.'#13#10'WAD:'+jwad+#13#10'texture n.'+strl(i+1,1)+#13#10);
    if csus then
    begin
     for j:=1 to ord(wadre.name[0]) do
     begin
      case wadre.name[j] of
      'a'..'z','A'..'Z','0'..'9','_','-':;
      '*','+':if j<>1 then werror('Strange characters in texture name:'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
      else werror('Strange characters in texture name:'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10)
      end;
     end;
    end;
    if wadre.typ<>68 then
     error ('Error: entry not a mipmap texture.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if wadre.len1<>wadre.len2 then
     werror ('Error: WAD2 entry probably compressed or corrupted.'#13#10+
     'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10+
     'filesize: '+strl(wadre.len1,1)+' / '+strl(wadre.len2,1)+' (should be the same)'#13#10);
    if wadre.com<>0 then
     werror ('Error: WAD2 entry is compressed.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    texi1[nwad]^[i]:=wadre.name;
    texi2[nwad]^[i].fpos:=wadre.pos;
    texi2[nwad]^[i].fsize:=wadre.len1;
   end;
   for i:= 0 to wade-1 do
   begin
    seek(f,texi2[nwad]^[i].fpos+16);
    blockread(f,mip,sizeof(mipin));
    if (((mip.x div 16)*16)<>mip.x) and (((mip.y div 16)*16)<>mip.y) then
     werror ('Error: invalid mipmap texture size.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if not(pix) then move(mip.t3,texi3[nwad]^[i],16);
    if mip.o1<>40 then
     werror ('Error: strange mipmap offset 1.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if mip.o2<>(mip.x*mip.y)+40 then
     werror ('Error: strange mipmap offset 2.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if mip.o3<>(mip.x*mip.y)div 4+mip.o2 then
     werror ('Error: strange mipmap offset 3.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if mip.o4<>(mip.x*mip.y)div 16+mip.o3 then
     werror ('Error: strange mipmap offset 4.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    if texi2[nwad]^[i].fsize<>(mip.x*mip.y)div 64+mip.o4 then
     werror ('Error: strange mipmap size.'#13#10'WAD:'+jwad+#13#10'texture:'+wadre.name+#13#10);
    inc(tmip,texi2[nwad]^[i].fsize);
    texi2[nwad]^[i].x:=mip.x;
    texi2[nwad]^[i].y:=mip.y;
    if pix then
    begin
     texi4[nwad]^[i][0]:=0;
     seek(f,texi2[nwad]^[i].fpos+40);
     bbit:=mip.x*mip.y;
     byts:=bbit;
     while (bbit>0) do
     begin
      tob:=bbit;
      if tob>filebuffersize then tob:=filebuffersize;
      blockread(f,b1^,tob);
      for n:=0 to (tob div 4)-1 do
      begin
       inc(texi4[nwad]^[i][0],b1^[n]);
      end;
      dec(bbit,tob);
     end;
    end else begin
     seek(f,texi2[nwad]^[i].fpos+40+mip.o2 div 2);
     blockread(f,texi4[nwad]^[i][0],8);
     seek(f,texi2[nwad]^[i].fpos+mip.o2+32);
     blockread(f,texi4[nwad]^[i][2],8);
    end;
    if ptex then begin
     tw:=texi1[nwad]^[i]+'               ';
     tw[0]:=#15;
     write(strl(i+1,4),' / ',kwad,' = ',tw,'  size=',strl(texi2[nwad]^[i].x,3),'x',strl(texi2[nwad]^[i].y,3)
     ,'  filesize=',strl(texi2[nwad]^[i].fsize,5),#13#10);
    end;
   end;
  end;
  if csus then begin
   inc(tmip,12+wade*32);
   if tmip<>lwad then write('Strange wad file size (wasted bytes?) Now is: ',lwad,' should be: ',tmip,#13#10);
  end;
  x1:
  close(f);
  inc(fpro);
  inc(tlwad,lwad);
  inc(twade,wade);
end;

{$ifdef timer}
var
 ta,tb,tc,td:word;
 tsec:longint;
{$endif}
label x;
begin
 {$ifdef timer}
 { gettime(ta,tb,tc,td);
  tsec:=(((ta*60+tb)*60+tc)*100+td);}
  tsec:=gettick;
 {$endif}
 {$ifdef debug}tmem:=0;{$endif}
 filemode:=0;
 write('WAD2 duplicate textures finder v1.2 by Bilbo'#13#10+
       'Email: hcl@post.cz  WWW: freeweb.coco.cz/petricm'#13#10+
       'type WADDUP -? for help'#13#10+
 {$ifdef DPMI}
 'Protected mode version'#13#10);
 {$else}
 'Real mode version'#13#10);
 {$endif}

 {begin processparams}
 i:=1;
 while (paramcount>=i) do
 begin
  s:=paramstr(i);
  case s[1] of
   '-','/':case s[2] of
     '?': begin
          write('Usage: WADDUP [filename.wad] [options]'#13#10+
                'You can use (multiple) wildcards'#13#10+
                'Options: -? this help'#13#10+
                '         -l only wadfile list and info'#13#10+
                '         -t print all texture info'#13#10+
                '         -w treat non-fatal errors as warnings'#13#10);
          write('         -s show also similar textures'#13#10+
                '         -x find dupes only across wads'#13#10+
                '         -i find dupes only inside wads'#13#10+
                '         -n different duplicate listing'#13#10+
                '         -a check for duplicate texture names'#13#10);
          write('         -c be case sensitive (use with -a)'#13#10+
                '         -e "Intelligent" compares'#13#10+
                '         -r check for suspicious things'#13#10+
                '         -u[name.wad] print status for wad'#13#10+
                '         -p compare by pixel-content'#13#10);
          error('Limits:max 4095 textures/wad, max 512 wadfiles, max 10920 similar textures'#13#10+
                '       max filesize 2 GB, max texture size 2 GB'#13#10);
          end;
     'a':chin:=true;
     'c':csen:=true;
     'e':iq:=true;
     'i':ins:=true;
     'l':list:=true;
     'n':nli:=true;
     'p':pix:=true;
     'r':csus:=true;
     's':part:=true;
     't':ptex:=true;
     'u':fwad:=copy(s,3,255);
     'w':err:=true;
     'x':cro:=true;
     else write('Unknown option :-'+s[2]+#13#10);
    end;
   else fmas:=s;
  end;
  inc(i);
 end;
 if ins and cro then error('-x and -i together doesn''t make sense.'#13#10);
 if paramcount=0 then error('No parameters given'#13#10);
 if fmas[0]=#0 then error('No filename given'#13#10);
 {end processparams}
 getmem(b1,filebuffersize);
 getmem(b2,filebuffersize);
 {$ifdef debug}  inc(tmem,2*filebuffersize); {$endif}
 if fwad[0]<>#0 then begin
  write('Getting status for wad:',fwad,#13#10);
  load_wadfile(fwad);
 end;
 ii:=1;
 while (paramcount>=ii) do
 begin
  fmas[0]:=#0;
  s:=paramstr(ii);
  case s[1] of
   '-','/':;
   else begin
    fmas:=s;
    FindFirst(fmas,Archive,D);
    while (DosError=0) do
    begin
     load_wadfile(d.name);
     FindNext(D);
    end;
   end;
  end;
  inc(ii);
 end;
 if not(list) then
 begin
  if nwad=0 then error('Error: No specified wadfiles found.'#13#10);
  write('Checking for duplicate textures/names:');
  if twade>46339 then Write('Total compares: more than 1 073 720 969'#13#10)
  else Write('Total compares:',(twade*twade+twade)div 2,#13#10);
  getmem(du,10920*6{sizeof(du)});
  getmem(du2,10920{sizeof(du)});
  {$ifdef debug}inc(tmem,76440{10920*7});{$endif}
  if fwad[0]<>#0 then
  begin
   if nwad<2 then error('No wadfile to compare with!');
   for j:=0 to wadt[1]-1 do
   begin
    du2^[j]:=0;
    for k:=2 to nwad do
    for l:=0 to wadt[k]-1 do
    begin
     cmpta(j,k,l);
     s1:=texi1[1]^[j];
     s2:=texi1[k]^[l];
     if csen then begin
      if (s1)=(s2) then du2^[j]:=du2^[j] or 2;{ident}
     end else begin
      if s1[0]=s2[0] then begin
       lowstr(s1);
       lowstr(s2);
       if (s1)=(s2) then du2^[j]:=du2^[j] or 2;{ident}
      end;
     end;
    end;
    texi1[1]^[j]:=texi1[1]^[j]+'               ';
    texi1[1]^[j][0]:=#15;
    Write(texi1[1]^[j],stat[du2^[j]]);
   end;
  end else begin
   for i:=1 to nwad do
   for j:=0 to wadt[i]-1 do
   begin
    for k:=i to nwad do
    begin
     if (k=i) then
     begin
      m:=j+1;
       if (m>wadt[k]-1)or cro then goto x;
     end else begin
      m:=0;
     end;
      for l:=m to wadt[k]-1 do
      begin
       cmpt(i,j,k,l);
       if chin then
       begin
        s1:=texi1[i]^[j];
        s2:=texi1[k]^[l];
        if csen then
        begin
         if (s1)=(s2) then begin
          write('Identical names: ',s1,'@',wads[i],'=',s2,'@',wads[k],#13#10);
          inc(inam);
         end;
        end else begin
         if s1[0]=s2[0] then begin
          lowstr(s1);
          lowstr(s2);
          if (s1)=(s2) then begin
            write('Identical names: ',texi1[i]^[j],' / ',wads[i],' = ',texi1[k]^[l],' / ',wads[k],#13#10);
           inc(inam);
          end;
         end;
        end;
       end;
      end;
    x:
     if ins then break;
    end;
   end;
  end;
  if chin then write('Number of identical texture names: ',inam,#13#10);
  write('Checking for duplicate textures (2nd step):'#13#10);
  write('Number of similar textures to be checked:',dui,#13#10);
  if dui>0 then
  for i:= 0 to dui-1 do
  begin
   l:=du^[i].f_w;
   m:=du^[i].t_w;
   j:=du^[i].f_t;
   k:=du^[i].t_t;
   assign(f,wads[l]);
   assign(g,wads[m]);
   reset(f,1);
   reset(g,1);
   seek(f,texi2[l]^[j].fpos+40);
   seek(g,texi2[m]^[k].fpos+40);
   bbit:=texi2[l]^[j].x*texi2[l]^[j].y;
   byts:=bbit;
   ok:=0;
   while (bbit>0) and (ok=0) do
   begin
    tob:=bbit;
    if tob>filebuffersize then tob:=filebuffersize;
    blockread(f,b1^,tob);
    blockread(g,b2^,tob);
    for n:=0 to (tob div 4)-1 do
    begin
     if b1^[n]<>b2^[n] then
     begin
      ok:=1;break;
     end;
    end;
    dec(bbit,tob);
   end;
   {checkfordupe}
   if iq and (ok=0) then
    begin
     c1:=texi1[l]^[j][1];
     d1:=texi1[m]^[k][1];
     c2:=texi1[l]^[j][2];
     d2:=texi1[m]^[k][2];
     if ((c1='+') and (d1<>'+')) or ((d1='+') and (c1<>'+')) then ok:=1
     else if ((c1='*') and (d1<>'*')) or ((d1='*') and (c1<>'*')) then ok:=1
     else if ((c1='+') and (d1='+')) then begin
     if (copy(texi1[l]^[j],3,255)=copy(texi1[m]^[k],3,255)) and (c2<>d2) then ok:=1;
     end;
    end;
   if ok=0 then begin
    if nli and (l=m) then write('Identical in ',wads[l],' : ',texi1[l]^[j],' = ',texi1[m]^[k],#13#10)
    else write('Identical: ',texi1[l]^[j],' / ',wads[l],' = ',texi1[m]^[k],' / ',wads[m],#13#10);
    inc(tbyt,byts);
    inc(itex);
   end;
   if pix and (ok=1) then begin
    seek(f,texi2[l]^[j].fpos+40);
    seek(g,texi2[m]^[k].fpos+40);
    bbit:=byts;
    for ok:=0 to 255 do
    begin
     pix1[ok]:=0;
     pix2[ok]:=0;
    end;
    while (bbit>0) do
    begin
     tob:=bbit;
     if tob>filebuffersize then tob:=filebuffersize;
     blockread(f,b1^,tob);
     blockread(g,b2^,tob);
     for n:=0 to (tob)-1 do
     begin
      inc(pix1[pu(b1)^[n]]);
      inc(pix2[pu(b2)^[n]]);
     end;
     dec(bbit,tob);
    end;
    ok:=0;
    for n:=0 to 255 do
    begin
     if pix1[n]<>pix2[n] then
     begin
      ok:=1;
      break;
     end;
    end;
    if iq and (ok=0) then
    begin
     c1:=texi1[l]^[j][1];
     d1:=texi1[m]^[k][1];
     c2:=texi1[l]^[j][2];
     d2:=texi1[m]^[k][2];
     if ((c1='+') and (d1<>'+')) or ((d1='+') and (c1<>'+')) then ok:=1
     else if ((c1='*') and (d1<>'*')) or ((d1='*') and (c1<>'*')) then ok:=1
     else if ((c1='+') and (d1='+')) then begin
     if (copy(texi1[l]^[j],3,255)=copy(texi1[m]^[k],3,255)) and (c2<>d2) then ok:=1;
     end;
    end;
    if ok=0 then
    begin
     if nli and (l=m) then write('Same pixels in ',wads[l],' : ',texi1[l]^[j],' = ',texi1[m]^[k],#13#10)
     else write('Same pixels: ',texi1[l]^[j],' / ',wads[l],' = ',texi1[m]^[k],' / ',wads[m],#13#10);
     inc(stex);
    end;
   end;
   close(f);
   close(g);
  end;
 end;
 write(' ----------- WADDUP Summary ------------'#13#10);
 if stex>0 then write(' Number of pixel-similar textures:',strl(stex,8),#13#10);
 if not(list) then write(' Number of identical textures:    ',strl(itex,8),#13#10+
       ' Wasted bytes (estimately)       :',strl((tbyt div 4)*5,8),#13#10+
       ' ---------------------------------------'#13#10);
 write('  Files processed : ',strl(fpro,9),#13#10+
       '  Total File size : ',strl(tlwad,9),#13#10+
       '  Total Entries   : ',strl(twade,9),#13#10);
 if tero>0 then write('  Errors found    : ',strl(tero,9),#13#10);
 {$ifdef debug}
  Write('Total Memory allocated:',tmem,#13#10);
  {write('Memory still free:',memavail,#13#10);}
 {$endif}
 {$ifdef timer}
{  gettime(ta,tb,tc,td);
  tsec:=(((ta*60+tb)*60+tc)*100+td)-tsec;}
  tsec:=gettick-tsec;
  Write('Finished in ',strul(tsec div 10),'.',char((tsec mod 10)+ord('0')),' seconds.');
 {$endif}
end.